/* Game downloaded from www.sumedhk.com 
   It has a few minor bugs which im pretty sure you can remove

   Compile - gcc gameser.c
*/

#include <stdio.h>
#include<stdlib.h>
#include<time.h>
#include<string.h>

#include"board.h"
#include"gamecli.h"

#define MAX 4          // Maximum number of player
int roll;              // Store roll value of dice
int turn[MAX]={0,0,0,0}; // 0-player off 1- player on(ready to play)
int flag=0;            // 0-game is not yet started, 1 game is started(minimum 2 players)
int playersize=0;            // Total number of players < MAX.

void display_info(void);
void player_request();
void roll_dice();
void bank_offer(int newplace,int playerID);  
void make_move(int roll,int playerID);


int main()
{
  int i=0,end,ch;
  srand(time(0));
  display_info();
  display_board();
  player_request();//pass player name as argument at client server time
  player_request();
  player_request();
  player_request();
  
  while(1)
    {
      for(i=0;i<4;i++)
	{
	  
	  if(turn[i]==1 && playersize>1)//checking for player is ready or not
	    {
	      ch=player_input(i+1);
	      if(ch==1)//roll the dice
		{
		  roll_dice();
		  printf("\nRoll for player%d = %d\n",i+1,roll);
		  make_move(roll,i+1);
		  display_player(i+1);
		}
	      if(ch==2)//sell property,station,utility
		{
		  //call sell();
		}
	      if(ch==3)//quit
		{
		  turn[i]=0;
		  playersize--;
		}
	    }
	  else
	    {
	       printf("\nRequired minimum 2 player");
	       exit(0);
	    }
	  // display_allplayer();
	}
      
      display_allplayer();
      display_board();
      printf("\nOne more round 1 - Yes, 2 - Exit: ");
      scanf("%d",&end);
      

      if(end==2)
	break;
    }

  return 0;
}

void display_info()
{
    printf("For yes type 'yes' and for no type 'no'\n");

}

// generate random number for roll of 2 dice
void roll_dice() 
{  
  roll= (rand()%11)+2;    
}

//set information for player
void player_request()
{
  int i,pid;
  struct user *temp;

  if(playersize>4)
    printf("\nSorry!!! Player size is Full\n");
  else
    {
      if(flag==1)
	printf("\nSorry!!! Game is already started.(Wait)\n");
      else
	{
	  for(i=0;i<MAX;i++)
	    {
	      if (turn[i]==0)
		{
		  pid=i+1; // player id
		  turn[i]=1; //setting player on
		  playersize++;
		  break;
		}
	    }
	  //  printf("\nWel-Come! Your Id = %d",pid);	  
	  
	  //setting the player information
	  
	  temp=(struct user*)malloc(sizeof(struct user));
	  
	  temp->id=pid;
	  strcpy(temp->name,"Nilesh"); //name from client
	  temp->balance=1500;
	  temp->place=1;	 
	  temp->totalproperty=0;
	  temp->totalstation=0;
	  temp->totalutility=0;
	  
	  player[i]=temp;
	}      
    }  
}

//make move on the board
void make_move(int roll,int playerID)
{
  int newplace;
  newplace = player[playerID-1]->place + roll;

  if(newplace<=24)
    {
      player[playerID-1]->place = newplace;
    }
  else
    {
      newplace=newplace-24;
      player[playerID-1]->place = newplace; //setting new place (after rotation on board)
      player[playerID-1]->balance += 200; //passing through go or on go place      
    }
  bank_offer(newplace,playerID);    
}

//bank offer given on board
void bank_offer(int newplace,int playerID)
{
  int placetype,ownedby;
  char ch[3];
  
  placetype = type[newplace-1];
  printf("\nnewplace = %d, place type = %d",newplace,placetype);
  
  switch (placetype)
    {
    case 2: // Property 
      printf("\nYou hold on Property %s",name[newplace-1]);
      if(owner[newplace-1]==0)
	{
	  printf("\nProperty cost = %d",cost[newplace-1]);
	  printf("\nDo you want to buy : ");
	  scanf("%s",ch);//string from client yes or no
	  if(strcmp(ch,"yes")==0)
	    {
	      printf("\nCongratulation! %s is Yours",name[newplace-1]);
	      player[playerID-1]->totalproperty++;//incrementing property owned by player
	      owner[newplace-1]=playerID;
	      player[playerID-1]->balance -= cost[newplace-1];
	    }
	}
      else
	{
	  ownedby = owner[newplace-1];
	  if(ownedby!=playerID)
	    {
	      printf("\nThis property owned by %s, ID = %d",player[ownedby-1]->name,ownedby);
	      printf("\nYou have to pay Rent of Rs. %d/- ",rent[newplace-1]);
		  
	      if(player[ownedby-1]->balance < rent[newplace-1])  	  
		{
		  printf("\n%s You are running out of balance",player[playerID-1]->name);  
		  //call to sell property
		}
	      else
		{
		  player[ownedby-1]->balance += rent[newplace-1];  	  
		  player[playerID-1]->balance -= rent[newplace-1];
		}
	    }
	}
      break;
    case 3: // Station
      printf("\nYou hold on Station %s",name[newplace-1]);
      if(owner[newplace-1]==0)
	{
	  printf("\nStation cost = %d",cost[newplace-1]);
	  printf("\nDo you want to buy : ");
	  scanf("%s",ch);//string from client yes or no
	  if(strcmp(ch,"yes")==0)
	    {
	      printf("\nCongratulation! %s is Yours",name[newplace-1]);
	      player[playerID-1]->totalstation++;//incrementing station owned by player
	      owner[newplace-1]=playerID;
	      player[playerID-1]->balance -= cost[newplace-1];
	    }
	}
      else
	{
	  ownedby = owner[newplace-1];
	  if(ownedby!=playerID)
	    {
	      
	      printf("\nThis Station owned by %s, ID = %d",player[ownedby-1]->name,ownedby);
	      printf("\nYou have to pay Rent of Rs. %d/- ",rent[newplace-1]);
	      player[ownedby-1]->balance += rent[newplace-1];  	  
	      player[playerID-1]->balance -= rent[newplace-1];
	    }
	}
      
      break;
    case 4: // Utility
      printf("\nYou hold on Utility %s",name[newplace-1]);
      if(owner[newplace-1]==0)
	{
	  printf("\nUtility cost = %d",cost[newplace-1]);
	  printf("\nDo you want to buy : ");
	  scanf("%s",ch);//string from client yes or no
	  if(strcmp(ch,"yes")==0)
	    {
	      printf("\nCongratulation! %s is Yours",name[newplace-1]);
	      player[playerID-1]->totalutility++;//incrementing property owned by player
	      owner[newplace-1]=playerID;
	      player[playerID-1]->balance -= cost[newplace-1];
	    }
	}
      break;
    case 5: // Chance 
      printf("\nYou hold on %s",name[newplace-1]);
      chance(roll,playerID);
      break;
    case 6: // Community Chest
      printf("\nYou hold on %s",name[newplace-1]);
      community_chest(roll,playerID);
      break;
    case 7: // Tax
      printf("\nYou hold on Tax %s",name[newplace-1]);
      printf("\nYou have to pay %d",cost[newplace-1]);
      player[playerID-1]->balance -= cost[newplace-1];
      break;
    case 8: // Jail
      printf("\nOops! You hold on %s",name[newplace-1]);
      printf("\nYou have to pay fine Rs. 50/-");
      player[playerID-1]->balance -= 50;
      break;
    case 9: // Parking
      printf("\nTake a rest! You hold on %s",name[newplace-1]);
      break;
    }
}
